@echo off

rem === check arg1
rem 
if "%1"=="fs" goto goodarg
if "%1"=="FS" goto goodarg
if "%1"=="pm" goto goodarg
if "%1"=="PM" goto goodarg

echo. usage: %0 option
echo.    with option: fs, FS, pm, or PM
echo.
goto done 

:goodarg

rem --- location of the file we want to patch 
rem     location of main.fte
rem 
setlocal

set TEXFTE=../contrib/ftetx004/config/tex.fte
set MAINFTE=../config/main.fte


rem === first we check if gnu-sed is available!

rem --- setup files for checking sed
rem
echo.check for sed >_testsed.$$1
echo.checked for sed >_testsed.$$2
echo.>_testsed.$$3

rem --- sed makes _testsed.$$3 equal to _testsed.$$2 
rem
sed -e "s/check/checked/" <_testsed.$$1 >_testsed.$$3

rem --- compare them now
rem caveat: "echo n" passes answers "no" to comp. 
rem         This should work for several languages (of OS/2) -- 
rem         but maybe you have to localize this!
rem
echo n >____comp.$$1
echo n >>____comp.$$1
comp _testsed.$$2 _testsed.$$3 1> nul 2>nul 0<____comp.$$1

if errorlevel 5 goto nosed
if errorlevel 4 goto someerror
goto havesed

rem === check complete

:nosed 
echo You don't have sed installed ! 
goto cleanup

:someerror
echo Some error running comp !
goto cleanup

:havesed
echo Patching %TEXFTE%
echo.
if "%1"=="fs" goto cftefs
if "%1"=="FS" goto cftefs

:cftepm
sed -e "s/^\#\%%define(TEX\_GUI)/\%%define(TEX\_GUI)/" %TEXFTE% > __texfte.$$1
sed -e "s/^\%%define(TEX\_FS)/\#\%%define(TEX\_FS)/" __texfte.$$1 > %TEXFTE% 
echo Compiling for PM 
echo on
cfte %MAINFTE% ftepm.cnf
@echo off

goto cleanup

:cftefs
sed -e "s/^\#\%%define(TEX\_FS)/\%%define(TEX\_FS)/" %TEXFTE% > __texfte.$$1
sed -e "s/^\%%define(TEX\_GUI)/\#\%%define(TEX\_GUI)/" __texfte.$$1 > %TEXFTE%
echo Compiling for FS 
echo on
cfte %MAINFTE% fte.cnf
@echo off

goto cleanup



:cleanup
rem === remove all temp files.
rem
if exist _testsed.$$1 del _testsed.$$1
if exist _testsed.$$2 del _testsed.$$2
if exist _testsed.$$3 del _testsed.$$3
if exist ____comp.$$1 del ____comp.$$1
if exist __texfte.$$1 del __texfte.$$1

:done
endlocal